#!/usr/bin/python
# coding: UTF-8
# Rec10 TS Recording Tools
# Copyright (C) 2009 Yukikaze
import commands
import re
import time
import tv2avi
import recdblist
def ts2x264(pin, pout, opts):#sizeは"HD"か"SD"
    """
    pinで指定されたファイルをpoutにx264でエンコードして書き出す
    """
    isAnime = 0
    if re.search("a", opts):
        isAnime = 1
    dualpass = 0
    resize=0
    isvfr=0
    size="Tall"
    if re.search("2", opts):
        dualpass = 1
    if re.search("H", opts):
        size = "HD"
    if re.search("S", opts):
        size = "SD"
    if re.search("F", opts):
        size = "FHD"
    if re.search("L", opts):
        size = "Short"
    if re.search("G", opts):
        size = "LowHD"
    if re.search("v", opts):
        isvfr=1
    encode(pin, pout,size,isvfr,dualpass)
def encode(pin,pout,size,isvfr,is2pass):
    encvf=""
    txt=""
    encvf="-vf yadif=0,pp=mb"
    harddup=",harddup"
    ofps="-ofps 30000/1001"
    bm=1
    scale=""
    x264enc1=""
    x264enc2=""
    crf=""
    if isvfr==1:
        ofps="-ofps 120000/1001"
        encvf="-vf pullup,softskip,pp=mb"
        #encvf="-vf filmdint=io=2997:119880,pp=mb"
        bm=4
        x264enc1=":me=hex:bframes=3"
        x264enc2=":frameref=3:subq=7:partitions=all:8x8dct:direct=auto:me=umh:bframes=3:weight_b"
        harddup=""
    if size == "HD":
        encvf = encvf + ",scale=1280:720::0:4"+harddup
        bitrate = "bitrate=" + str(tv2avi.Bitrate_HD*bm)
        crf="crf=20"
    elif size == "SD":
        encvf = encvf + ",scale=720:480::0:4"+harddup
        bitrate = "bitrate=" + str(tv2avi.Bitrate_SD*bm)
        crf="crf=20"
    elif size == "FHD":
        encvf = encvf + ",scale=1920:1080::0:4"+harddup
        bitrate = "bitrate=" + str(tv2avi.Bitrate_FHD*bm)
        crf="crf=22"
    elif size == "Short":
        encvf = encvf +harddup
        bitrate = "bitrate=" + str(tv2avi.Bitrate_Short*bm)
        crf="crf=20"
    elif size == "LowHD":
        encvf = encvf + ",scale=1280:720::0:4"+harddup
        bitrate = "bitrate=" + str(tv2avi.Bitrate_LowHD*bm)
        crf="crf=22"
    else:
        encvf = encvf + ",scale=1280:720::0:4"+harddup
        bitrate = "bitrate=" + str(tv2avi.Bitrate_HD*bm)
        crf="crf=22"
    if is2pass == 1:
        pas1exe = "mencoder \'" + pin + "\' -quiet -nosound -sws 9 -ovc x264 " + encvf + " "+ofps+" -x264encopts " + bitrate +x264enc1+ ":threads=auto:level_idc=41:pass=1:turbo=2 -passlogfile \'" + pin + ".log\' " + " -o /dev/null"
        pas2exe = "mencoder \'" + pin + "\' -quiet -sws 9 -ovc x264 " + encvf + " "+ofps+" -x264encopts " + bitrate +x264enc2+ ":level_idc=41:threads=auto:pass=2 -passlogfile \'" + pin + ".log\' -oac faac -o \'" + pout + "\'"
        pas1exe = "nice -n 19 " + pas1exe
        pas2exe = "nice -n 19 " + pas2exe
        recdblist.printutf8(pas1exe)
        txt=txt+unicode(commands.getoutput(pas1exe.encode('utf-8')),'utf-8')
        recdblist.printutf8(pas2exe)
        time.sleep(5)
        txt=txt+unicode(commands.getoutput(pas2exe.encode('utf-8')),'utf-8')
    else:
        pas1exe = "mencoder \'" + pin + "\' -quiet -sws 9 -ovc x264 " + encvf + " "+ofps+" -x264encopts " + bitrate +x264enc2+":level_idc=41:threads=auto -oac faac -o \'" + pout + "\'"
        pas1exe = "nice -n 19 " + pas1exe
        recdblist.printutf8(pas1exe)
        txt=txt+unicode(commands.getoutput(pas1exe.encode('utf-8')),'utf-8')
    logo=pin
    logo=logo.replace(".sa.avi",".ts")
    logo=logo.replace(".ts",".log")
    f=open(logo,'a')
    s=len(txt)
    stxt=""
    if s>100:
        stxt=txt[s-300:]
    else:
        stxt=txt
    s=stxt.find("\n")
    if s>0:
        s=s+len("\n")
        stxt=stxt[s:]
    txt="\n####mencoder-log_"+size+"####\n"+stxt
    f.write(txt.encode('utf-8'))
    f.close()